-- FSUB_S_2
-- ソースオペランドの符合は一致しているものとする

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity FSUB_S_2 is

	port(MANT_buf2 : in std_logic_vector(26 downto 0);
             Neq      : in std_logic;
             W_exp     : in std_logic_vector(7 downto 0);
	     OUTPUT    : out std_logic_vector(30 downto 0));

end FSUB_S_2;

architecture STRUCTURE of FSUB_S_2 is
component Priority31_sub
       port(bits : in std_logic_vector(31 downto 0);
            Code_out : out std_logic_vector(4 downto 0));
end component;
component LeftShifter31_sub
    	  port(Data    : in std_logic_vector(31 downto 0);
    	       nShift   : in std_logic_vector(4 downto 0);
	         Shifted : out std_logic_vector(23 downto 0));
end component;

--signal Data : std_logic_vector(23 downto 0);  -- input to RightShifter
--signal nShift : std_logic_vector(7 downto 0); -- input to RightShifter
signal EXP : std_logic_vector(7 downto 0);
--signal EXPns : std_logic_vector(7 downto 0);
--signal EXPs : std_logic_vector(7 downto 0);
--signal L_MANT_buf : std_logic_vector(26 downto 0);
--signal L_MANT_bufns : std_logic_vector(26 downto 0);
--signal MANT_buf : std_logic_vector(26 downto 0);
--signal MANT_bufns : std_logic_vector(26 downto 0);
--signal MANT_buf2ns : std_logic_vector(26 downto 0);    -- MANT_bufを丸め
signal MANT_INPUT : std_logic_vector(31 downto 0); -- input to Priority31,LeftShifter31
signal MANT_INPUT2 : std_logic_vector(31 downto 0); -- input to Priority31,LeftShifter31
signal POSITION_MSB : std_logic_vector(4 downto 0);  -- MANT_buf2の先頭の1の位置
--signal MANT_INPUTns : std_logic_vector(31 downto 0); -- input to Priority31,LeftShifter31
--signal MANT_INPUT2ns : std_logic_vector(31 downto 0); -- input to Priority31,LeftShifter31
--signal POSITION_MSBns : std_logic_vector(4 downto 0);  -- MANT_buf2の先頭の1の位置
signal MANT : std_logic_vector(22 downto 0);
--signal MANTns : std_logic_vector(22 downto 0);
--signal MANTs : std_logic_vector(22 downto 0);
signal MANTb : std_logic_vector(23 downto 0);
--signal MANTc : std_logic_vector(31 downto 0);

signal OUTEXPis0 : std_logic;
signal O : std_logic;
signal Os : std_logic_vector(8 downto 0);

--signal InfS : std_logic;
begin -- STRUCTURE

   MANT_INPUT <= "00000" & MANT_buf2;
   Priority31_2 : Priority31_sub port map (MANT_INPUT,POSITION_MSB);
   EXP <= W_exp - ("11010" - POSITION_MSB) when MANTb /= "111111111111111111111111" else
          W_exp - ("11001" - POSITION_MSB);    -- (Ｗ数の指数) - (26-(プライオリティエンコーダの出力))
   
   MANT_INPUT2 <= "00000" & MANT_buf2;
   LeftShifter31_2 : LeftShifter31_sub port map (MANT_INPUT2,POSITION_MSB,MANTb);
   --MANTc <= shl(MANT_INPUT2,(not POSITION_MSB));

   MANT <= MANTb(23 downto 1)+MANTb(0);
   --MANT <= MANTc(30 downto 8);
     
   OUTEXPis0 <= '1' when EXP = 0 else '0';
   
   O <= not OUTEXPis0;   
   Os <= (others => O);
   OUTPUT <= Os & "0000000000000000000000"                when OUTEXPis0 = '1' else
             EXP & MANT;                                 -- MANT(31 downto 9) = MANTISSA
             
end STRUCTURE;
